﻿Type=Class
Version=2.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private Base As AnchorPane
	
	Private Chars(14) As Image
	Private Digits(10) As ImageView
	
	Private mValue As String
	Private Scale=.5 As Double
	Private mWidth As Double
	Private mHeight As Double
	

	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Owner As Form, EventName As String)
	Base.Initialize("")
	InitChars
	mValue=""
	Draw(mValue)
	'Base.Style="-fx-background-color:linear-gradient(to right,lightgray, darkgray)"
	Base.Style="-fx-background-color:lightblue;)"
	'Base.Style = "-fx-background-image:url('" & File.GetUri(File.DirAssets, "england.png") & "');"
	
End Sub

Public Sub UI() As AnchorPane
	Return Base
End Sub

Sub InitChars()
	For i=0 To 13
	Chars(i).Initialize(File.DirAssets,i&".png")
	Next
	For i=0 To 9
		Digits(i).Initialize("")
		Base.AddNode(Digits(i),-1000,0,1,1)
		Digits(i).SetImage(Chars(0))
		Digits(i).Visible=False
	Next
End Sub

Public Sub setValue(newValue As String)
	mValue=newValue
	Draw(mValue)
End Sub

Sub Draw(newValue As String)	
	Dim digit="" As String
	Dim x=0 As Double
	Dim y=0 As Double
	Dim dx=0 As Double
	Dim num As Int
	
	For i=0 To 9
		Digits(i).Left=-1000
	Next
	
	Do While (mValue.length<newValue.length)

		mValue=mValue+" "
	Loop
	
	For i=0 To newValue.Length-1
		digit=newValue.SubString2(i, i+1)
		Digits(i).left=x
	    If digit=" " Then
			dx=changeLayout(i,10)
	    Else If digit=":" Then
			dx=changeLayout(i,12)
	  	Else If digit="." Then
			dx=changeLayout(i,11)
	  	Else If digit="-" Then
			dx=changeLayout(i,13)
	 	Else 
			num=digit
			dx=changeLayout(i,num)
	  	End If
		x=x+dx
  	Next

	mValue=newValue
    Base.PrefWidth=x
    Base.PrefHeight=Digits(0).Height-10
    mWidth=Base.PrefWidth
    mHeight=Base.PrefHeight
End Sub

Sub  changeLayout(Index As Int,charIndex  As Int) As Double

	Digits(Index).setImage(Chars(charIndex))
	Digits(Index).Width=Chars(charIndex).Width*Scale
	Digits(Index).Height=Chars(charIndex).Height*Scale
	'Digits(Index).PreserveRatio=True
	Digits(Index).visible=True
	Return Digits(Index).Width
End Sub

Public Sub getWidth() As Double
	Return mWidth
End Sub
Public Sub setWidth(width As Double)
	Scale=width*Scale/mWidth
	setValue(mValue)
End Sub

Public Sub getHeight() As Double
	Return mHeight
End Sub

Public Sub setHeight(height As Double)
	Scale=height*Scale/mHeight
	mHeight=height
	setValue(mValue)
End Sub

Public Sub getTop() As Double
	Return Base.Top
End Sub
Public Sub setTop(top As Double)
	Base.top=top	   
End Sub

Public Sub getLeft() As Int
	Return Base.Left
End Sub
Public Sub setLeft(left As Double)
	Base.left=left	   
End Sub